#include <time.h>
#include <stdlib.h>
#include <stdio.h>
#include <simics/magic-instruction.h>

int main(int argc, char* argv[]){
	int i = 0;
	int size = 0;
	int *v;
	int *w;
	int *z;

	if(argc != 2 || argc == 0){
		printf("USAGE: vector_add <size of vector>\n");
		return 1;
	}

	size = atoi(argv[1]);	

	v = malloc( size * sizeof(int));
	w = malloc( size * sizeof(int));
	z = malloc( size * sizeof(int));
	if ( v == NULL || w == NULL || z == NULL) {
		printf("Could not allocate memory.");
		return 1;
	}

	// bring the vectors into VM/cache by memsetting them
	memset(v, 0, size * sizeof(int));
	memset(w, 0, size * sizeof(int));
	memset(z, 0, size * sizeof(int));
		
	MAGIC_BREAKPOINT; //A noop which will cause Simics to breakpoint

	for(i = 0; i < size; i++){
	   z[i] =  v[i] + w[i]; 
	}

	MAGIC_BREAKPOINT; //A noop which will cause Simics to breakpoint

	free(v);
	free(w);
	return 0;
}
